Package com.google.javascript.jscomp.type

# Interface ReverseAbstractInterpreter

All Known Implementing Classes:
  `ChainableReverseAbstractInterpreter`, `ClosureReverseAbstractInterpreter`, `SemanticReverseAbstractInterpreter`

public interface ReverseAbstractInterpreter
This interface defines what reversed abstract interpreters provide.

Abstract interpretation is the process of interpreting a program at an abstracted level (such as at the type level) instead of the concrete level (the flow of values). This reversed abstract interpreter reverses the abstract interpretation process by knowing the outcome of some computation and calculating a preciser view of the world than the view without knowing the outcome of the computation.

## Method Summary

Modifier and Type
Method
Description
`FlowScope`
`getPreciserScopeKnowingConditionOutcome(Node condition, FlowScope blindScope, boolean outcome)`
Calculates a precise version of the scope knowing the outcome of the condition.

## Method Details

### getPreciserScopeKnowingConditionOutcome

FlowScope getPreciserScopeKnowingConditionOutcome(Node condition, FlowScope blindScope, boolean outcome)
Calculates a precise version of the scope knowing the outcome of the condition.

Parameters:
  `condition` - the condition's expression
  `blindScope` - the scope without knowledge about the outcome of the condition
  `outcome` - the outcome of the condition